package mocman.interpreter;

import java.util.*;
import java.awt.*;
import java.awt.event.*;
import mocman.interpreter.syntax.*;
import mocman.interpreter.syntax.token.*;
import mocman.interpreter.*;
import java.awt.geom.AffineTransform;
import java.awt.image.BufferedImage;

class Structogram extends Canvas
{
	public Structogram(Interpreter t)
	{
		ipt=t;
	}
	private int max(int a,int b)
	{
		if (a<b) return b;
		return a;
	}
	public Interpreter ipt;
	public int draw(Graphics2D img,int from,int to,int x1,int y1,int x2,int y2)
	{
		int c=0;
		if (from>=to) return 0;
		int mrc=getRowCount(from,to);
		if (mrc==0) return 0;
		int h=(y2-y1)/mrc;
		
		img.setColor(new Color(1.0f,1.0f,1.0f,0.5f));
		img.fillRect(x1,y1,(x2-x1),mrc*h-1);
		img.setColor(java.awt.Color.black);
		img.drawRect(x1,y1,(x2-x1),mrc*h-1);
		img.setColor(java.awt.Color.white);
		for (int i=from;i<to;i++)
		{
			SyntaxTree t=ipt.rows.get(i).getTree();
			if (t!=null)
			{
				int k=t.getChild();
				if (Tokenizer.getTokenName(k).equals("WHILE"))
				{
					int m=getRowCount(i+1,ipt.rows.get(i).placeF-1)+1;
					int k2=ipt.rows.get(i).placeF;
					if (ipt.getPlaceHolder()==i) 
					{
						GradientPaint gp = new GradientPaint(
							x1, y1+c*h, Color.blue.brighter(),
							x1, y1+600, Color.white );

						img.setPaint( gp );
						img.fillRect(x1,y1+c*h,x2,h*m);
					}
					img.setColor(java.awt.Color.black);
					img.drawRect(x1,y1+c*h,x2,h*m);
					img.drawString(ipt.rows.get(i).getValue(),x1+2,y1+(c+1)*h-2);
					draw(img,i+1,ipt.rows.get(i).placeF-1,x1+(x2-x1)/10,y1+(c+1)*h,x2,y1+(c+1)*h+h*(m-1));
					c=c+m;
					//i=ipt.rows.get(k2).placeF;
					i=k2-1;
				}
				else
				if (Tokenizer.getTokenName(k).equals("IF"))
				{
					int m=0;
					int k2=ipt.rows.get(i).placeF-1;
					if (ipt.getPlaceHolder()==i) 
					{
						GradientPaint gp = new GradientPaint(
							x1, y1+c*h, Color.blue.brighter(),
							x1, y1+600, Color.white );
						img.setPaint( gp );
						img.fillRect(x1,y1+c*h,x2-x1,h);
					}
					img.setColor(java.awt.Color.black);
					img.drawRect(x1,y1+c*h,x2-x1,h);
					img.drawString(ipt.rows.get(i).getValue(),x1+2,y1+(c+1)*h-2);
					int m2=getRowCount(i+1,ipt.rows.get(i).placeF-1);
					int m3=draw(img,i+1,ipt.rows.get(i).placeF-1,x1+1,y1+(c+1)*h,x1+(x2-x1)/2-1,y1+(c+1)*h+h*m2);
					if (Tokenizer.getTokenName(ipt.rows.get(k2).getTree().getChild()).equals("ELSE"))
					{
						int m4=getRowCount(k2+1,ipt.rows.get(k2).placeF-1);
						m=draw(img, k2+1,ipt.rows.get(k2).placeF-1,x1+(x2-x1)/2,y1+(c+1)*h,x2-2,y1+(c+1)*h+h*m4);
					}
					else
					{
						img.setColor(java.awt.Color.white);
						img.fillRect(x1+(x2-x1)/2,y1+(c+1)*h,(x2-x1)/2,m3*h);
						img.setColor(java.awt.Color.black);
						img.drawRect(x1+(x2-x1)/2,y1+(c+1)*h,(x2-x1)/2,m3*h);
					}
					c=c+max(m3,m)+1;
					i=ipt.rows.get(k2).placeF-1;
				}
				else
				if (Tokenizer.getTokenName(k).equals("ELSE")) {}
				else
				if (Tokenizer.getTokenName(k).equals("END")) {}
				else
				{
					if (ipt.getPlaceHolder()==i) 
					{
						GradientPaint gp = new GradientPaint(
							x1, y1+c*h, Color.blue.brighter(),
							x1, y1+600, Color.white );

						img.setPaint( gp );
						img.fillRect(x1,y1+c*h,(x2-x1),h);
					}
					img.setColor(java.awt.Color.black);
					img.drawRect(x1,y1+c*h,(x2-x1),h);
					img.drawString(ipt.rows.get(i).getValue(),x1+2,y1+(c+1)*h-2);
					c=c+1;
				}
			}
		}
		return c;
	}

	public int getRowCount(int from,int to)
	{
		int c=0;
		if (from>=to) return 0;
		
		for (int i=from;i<to;i++)
		{
			SyntaxTree t=ipt.rows.get(i).getTree();
			if (t!=null)
			{
				int k=t.getChild();
				if (Tokenizer.getTokenName(k).equals("WHILE"))
				{
					int m=getRowCount(i+1,ipt.rows.get(i).placeF-1)+1;
					int k2=ipt.rows.get(i).placeF;
					c=c+m;
					//i=ipt.rows.get(k2).placeF;
					i=k2-1;
				}
				else
				if (Tokenizer.getTokenName(k).equals("IF"))
				{
					int m=0;
					int k2=ipt.rows.get(i).placeF-1;
					if (Tokenizer.getTokenName(ipt.rows.get(k2).getTree().getChild()).equals("ELSE"))
					{
						m=getRowCount(k2+1,ipt.rows.get(k2).placeF-1);
//						System.out.println("m:"+m);
					}
					c=c+max(getRowCount(i+1,ipt.rows.get(i).placeF-1),m)+1;
					i=ipt.rows.get(k2).placeF-1;
				}
				else
				if (Tokenizer.getTokenName(k).equals("ELSE")) {}
				else
				if (Tokenizer.getTokenName(k).equals("END")) {}
				else
				{
					c=c+1;
				}
			}
		}
		//System.out.println(""+from+":"+to+"="+c);
		return c;
	}
	public void paint(Graphics g1) 
	{
	    Graphics2D g = (Graphics2D) g1;
	    BufferedImage image = // Create an off-screen image
   	 	new BufferedImage(getWidth(), getHeight(), BufferedImage.TYPE_INT_RGB);
		Graphics2D ig = image.createGraphics(); // Get its Graphics for drawing
		ig.setRenderingHint(RenderingHints.KEY_ANTIALIASING, // Anti-alias!
        RenderingHints.VALUE_ANTIALIAS_ON);
		//ig.setColor(java.awt.Color.white);
		GradientPaint gp = new GradientPaint(
	    0, 0, getBackground(),
   		0, getHeight(), getBackground().darker() );
		ig.setPaint( gp );
		ig.fillRect(0,0,getWidth(),getHeight());
		draw(ig,0,ipt.rows.size(),0,0,getWidth()-2,getHeight()-2);
		g.drawImage(image, 0, 0, this);
	} 
	public void update(Graphics g) 
	{
		paint(g);
	}

}
