package mocman.interpreter.modules;

import java.util.*;
import mocman.util.*;
import mocman.interpreter.*;
import mocman.interpreter.syntax.*;

public class Str extends Module
{
	private static Universe<String> univ=new Universe<String>();
	public Str clone()
	{
		Str g=new Str();
		g.setValue(getVal());
		return g;
	}

	public ITreeNode value(String s)
	{
		Str l=new Str();
		l.setValue(s);
		return l;
	}

	public ITreeNode get(ITreeNode n)
	{
		Str p=new Str();
		p.strVal=univ.get(n.getVal(),"");
		return p;
	}
	public ITreeNode set(ITreeNode i,ITreeNode v)
	{
		ITreeNode p=new Str();
		univ.set(i.getVal(),v.getVal());
		p.setValue(v.getVal());
		return p;
	}
	public ITreeNode function(ITreeNode n)
	{
		if (getVal().equals("set"))
		{
			univ.set(n.getVal(),n.getNext().getVal());
			return n;
		}
		if (getVal().equals("get"))
		{
			return value(univ.get(n.getVal(),""));
		}
		if (getVal().equals("concat"))
		{
			StringBuilder s=new StringBuilder();
			//s.append(n.getVal());
			ITreeNode m=n;
			while (!m.isEpsilon())
			{
				s.append(m.getVal());
				m=m.getNext();
			}
			return value(s.toString());
		}else
		if (getVal().equals("substring"))
		{
			int x=0;
			int y=n.getVal().length();
			if (!n.getNext().isEpsilon())
			{
				x=Integer.parseInt(n.getNext().getVal());
				if (!n.getNext().getNext().isEpsilon())
				{
					y=Integer.parseInt(n.getNext().getNext().getVal());
				}
			}
			return value(n.getVal().substring(x,y));	
		}else
		if (getVal().equals("length"))
		{
			return value((new Integer(n.getVal().length())).toString());
		}
		return value("0"); //return false
	}
}
