package mocman.interpreter.syntax;

import mocman.interpreter.*;
import mocman.interpreter.syntax.token.*;
public class Generated
{
	public static void generate()
	{
		//Generating terminal symbols
		Tokenizer.addTokenType("while",1);
		Tokenizer.addTokenType("valueof",2);
		Tokenizer.addTokenType("true",3);
		Tokenizer.addTokenType("then",4);
		Tokenizer.addTokenType("return",5);
		Tokenizer.addTokenType("procedure",6);
		Tokenizer.addTokenType("print",7);
		Tokenizer.addTokenType("pause",8);
		Tokenizer.addTokenType("or",9);
		Tokenizer.addTokenType("not",10);
		Tokenizer.addTokenType("message",11);
		Tokenizer.addTokenType("loop",12);
		Tokenizer.addTokenType("input",13);
		Tokenizer.addTokenType("imageof",14);
		Tokenizer.addTokenType("if",15);
		Tokenizer.addTokenType("false",16);
		Tokenizer.addTokenType("end",17);
		Tokenizer.addTokenType("else",18);
		Tokenizer.addTokenType("call",19);
		Tokenizer.addTokenType("and",20);
		Tokenizer.addTokenType("\\]",21);
		Tokenizer.addTokenType("\\[",22);
		Tokenizer.addTokenType("\\.",23);
		Tokenizer.addTokenType("\\+",24);
		Tokenizer.addTokenType("\\*",25);
		Tokenizer.addTokenType("\\)",26);
		Tokenizer.addTokenType("\\(",27);
		Tokenizer.addTokenType("\\$",28);
		Tokenizer.addTokenType("\'[^\']*\'",29);
		Tokenizer.addTokenType("[a-zA-Z][a-zA-Z0-9_]*",30);
		Tokenizer.addTokenType("[1-9][0-9]*",31);
		Tokenizer.addTokenType(">=",32);
		Tokenizer.addTokenType(">",33);
		Tokenizer.addTokenType("=",34);
		Tokenizer.addTokenType("<=",35);
		Tokenizer.addTokenType("<",36);
		Tokenizer.addTokenType(";",37);
		Tokenizer.addTokenType(":=",38);
		Tokenizer.addTokenType("0",39);
		Tokenizer.addTokenType("/",40);
		Tokenizer.addTokenType("->",41);
		Tokenizer.addTokenType("-",42);
		Tokenizer.addTokenType(",",43);
		Tokenizer.addTokenType("%",44);
		Tokenizer.addTokenType("!",45);
		Tokenizer.addTokenType("#",46);
		//Generating non-terminal symbols
		Tokenizer.addTokenType("_START",100);
		Tokenizer.addTokenType("ACTPARAM'",101);
		Tokenizer.addTokenType("ACTPARAMLIST",102);
		Tokenizer.addTokenType("ACTPARAMLISTPLUS",103);
		Tokenizer.addTokenType("ACTPARAMS",104);
		Tokenizer.addTokenType("ADDOP",105);
		Tokenizer.addTokenType("ARRAY",106);
		Tokenizer.addTokenType("ARRAYB",107);
		Tokenizer.addTokenType("ARRAYB'",108);
		Tokenizer.addTokenType("ELSE",109);
		Tokenizer.addTokenType("ENDSOMETHING",110);
		Tokenizer.addTokenType("EQOP",111);
		Tokenizer.addTokenType("EVAL",112);
		Tokenizer.addTokenType("EVALCALL",113);
		Tokenizer.addTokenType("FORMPARAM'",114);
		Tokenizer.addTokenType("FORMPARAMID",115);
		Tokenizer.addTokenType("FORMPARAMLIST",116);
		Tokenizer.addTokenType("FORMPARAMPLUS",117);
		Tokenizer.addTokenType("FORMPARAMS",118);
		Tokenizer.addTokenType("IDENTIFIER",119);
		Tokenizer.addTokenType("IF",120);
		Tokenizer.addTokenType("IMG",121);
		Tokenizer.addTokenType("INPUTPARAM",122);
		Tokenizer.addTokenType("INT",123);
		Tokenizer.addTokenType("INTADD",124);
		Tokenizer.addTokenType("INTADD1",125);
		Tokenizer.addTokenType("INTAND",126);
		Tokenizer.addTokenType("INTAND1",127);
		Tokenizer.addTokenType("INTEGER",128);
		Tokenizer.addTokenType("INTEQ",129);
		Tokenizer.addTokenType("INTEQ1",130);
		Tokenizer.addTokenType("INTIMP",131);
		Tokenizer.addTokenType("INTIMP1",132);
		Tokenizer.addTokenType("INTMUL",133);
		Tokenizer.addTokenType("INTMUL1",134);
		Tokenizer.addTokenType("INTN",135);
		Tokenizer.addTokenType("INTOR",136);
		Tokenizer.addTokenType("INTOR1",137);
		Tokenizer.addTokenType("INTV",138);
		Tokenizer.addTokenType("LEFTVALUE",139);
		Tokenizer.addTokenType("MODULE",140);
		Tokenizer.addTokenType("MULOP",141);
		Tokenizer.addTokenType("PRN",142);
		Tokenizer.addTokenType("PROGRAM",143);
		Tokenizer.addTokenType("RETURN",144);
		Tokenizer.addTokenType("RETURNSTATE",145);
		Tokenizer.addTokenType("SEQFIRST",146);
		Tokenizer.addTokenType("SEQNEXT",147);
		Tokenizer.addTokenType("SEQUENTIAL",148);
		Tokenizer.addTokenType("STATEMENT",149);
		Tokenizer.addTokenType("STR",150);
		Tokenizer.addTokenType("STRING",151);
		Tokenizer.addTokenType("WHILE",152);
		Tokenizer.addTokenType("epsilon",153);
		//Generating rules
		Rules.addRule(128,new int[] {131});//1
		Rules.addRule(131,new int[] {136,132});//2
		Rules.addRule(132,new int[] {41,136,132});//3
		Rules.addRule(132,new int[] {153});//4
		Rules.addRule(136,new int[] {126,137});//5
		Rules.addRule(137,new int[] {9,124,137});//6
		Rules.addRule(137,new int[] {153});//7
		Rules.addRule(126,new int[] {129,127});//8
		Rules.addRule(127,new int[] {20,129,127});//9
		Rules.addRule(127,new int[] {153});//10
		Rules.addRule(129,new int[] {124,130});//11
		Rules.addRule(130,new int[] {111,124,130});//12
		Rules.addRule(130,new int[] {153});//13
		Rules.addRule(124,new int[] {133,125});//14
		Rules.addRule(125,new int[] {105,133,125});//15
		Rules.addRule(125,new int[] {153});//16
		Rules.addRule(133,new int[] {135,134});//17
		Rules.addRule(134,new int[] {141,135,134});//18
		Rules.addRule(134,new int[] {153});//19
		Rules.addRule(135,new int[] {10,138});//20
		Rules.addRule(135,new int[] {138});//21
		Rules.addRule(138,new int[] {27,128,26});//22
		Rules.addRule(138,new int[] {123});//23
		Rules.addRule(138,new int[] {42,123});//24
		Rules.addRule(141,new int[] {25});//25
		Rules.addRule(141,new int[] {40});//26
		Rules.addRule(141,new int[] {44});//27
		Rules.addRule(105,new int[] {24});//28
		Rules.addRule(105,new int[] {42});//29
		Rules.addRule(111,new int[] {34});//30
		Rules.addRule(111,new int[] {10,34});//31
		Rules.addRule(111,new int[] {35});//32
		Rules.addRule(111,new int[] {32});//33
		Rules.addRule(111,new int[] {36});//34
		Rules.addRule(111,new int[] {33});//35
		Rules.addRule(123,new int[] {39});//36
		Rules.addRule(123,new int[] {31});//37
		Rules.addRule(123,new int[] {3});//38
		Rules.addRule(123,new int[] {16});//39
		Rules.addRule(123,new int[] {139});//40
		Rules.addRule(123,new int[] {2,139,102});//41
		Rules.addRule(123,new int[] {13,122});//42
		Rules.addRule(122,new int[] {153});//43
		Rules.addRule(122,new int[] {151});//44
		Rules.addRule(150,new int[] {29});//45
		Rules.addRule(139,new int[] {140,106});//46
		Rules.addRule(140,new int[] {28,119,23,119});//47
		Rules.addRule(140,new int[] {119});//48
		Rules.addRule(106,new int[] {22,107,21,106});//49
		Rules.addRule(106,new int[] {153});//50
		Rules.addRule(107,new int[] {128,108});//51
		Rules.addRule(108,new int[] {153});//52
		Rules.addRule(108,new int[] {43,128});//53
		Rules.addRule(119,new int[] {30});//54
		Rules.addRule(120,new int[] {15,128,4});//55
		Rules.addRule(109,new int[] {18});//56
		Rules.addRule(110,new int[] {15});//57
		Rules.addRule(152,new int[] {12,1,128});//58
		Rules.addRule(110,new int[] {12});//59
		Rules.addRule(113,new int[] {38,128});//60
		Rules.addRule(113,new int[] {102});//61
		Rules.addRule(112,new int[] {139,113});//62
		Rules.addRule(112,new int[] {19,139,102});//63
		Rules.addRule(102,new int[] {27,101,26});//64
		Rules.addRule(101,new int[] {104});//65
		Rules.addRule(101,new int[] {153});//66
		Rules.addRule(104,new int[] {128,103});//67
		Rules.addRule(104,new int[] {151,103});//68
		Rules.addRule(103,new int[] {43,104});//69
		Rules.addRule(103,new int[] {153});//70
		Rules.addRule(143,new int[] {6,119,116});//71
		Rules.addRule(116,new int[] {27,114,26});//72
		Rules.addRule(114,new int[] {118});//73
		Rules.addRule(114,new int[] {153});//74
		Rules.addRule(118,new int[] {115,117});//75
		Rules.addRule(115,new int[] {119});//76
		Rules.addRule(115,new int[] {45,112});//77
		Rules.addRule(117,new int[] {43,118});//78
		Rules.addRule(117,new int[] {153});//79
		Rules.addRule(144,new int[] {5,145});//80
		Rules.addRule(145,new int[] {153});//81
		Rules.addRule(145,new int[] {128});//82
		Rules.addRule(148,new int[] {146,147});//83
		Rules.addRule(147,new int[] {37,148});//84
		Rules.addRule(147,new int[] {153});//85
		Rules.addRule(146,new int[] {144});//86
		Rules.addRule(146,new int[] {112});//87
		Rules.addRule(149,new int[] {120});//88
		Rules.addRule(149,new int[] {109});//89
		Rules.addRule(149,new int[] {152});//90
		Rules.addRule(149,new int[] {143});//91
		Rules.addRule(149,new int[] {148});//92
		Rules.addRule(149,new int[] {17,110});//93
		Rules.addRule(149,new int[] {7,142});//94
		Rules.addRule(149,new int[] {11,142});//95
		Rules.addRule(149,new int[] {8});//96
		Rules.addRule(110,new int[] {6});//97
		Rules.addRule(142,new int[] {128});//98
		Rules.addRule(142,new int[] {151});//99
		Rules.addRule(142,new int[] {153});//100
		Rules.addRule(151,new int[] {150});//101
		Rules.addRule(151,new int[] {14,121});//102
		Rules.addRule(121,new int[] {139,102});//103
		Rules.addRule(153,new int[] {});//104
		Rules.addRule(100,new int[] {149,46});
		Rules.setStartingRule("STATEMENT");
		Rules.makeTable();
	}
	
	public static ITreeNode semantic(ITreeNode parent,ITreeNode[] p)
	{
		if (p.length==0) return parent;
		switch (parent.getRule())
			{
				case (1): {if (!p[1].isEpsilon()) {return Global.imp(p[0],p[1]);} return p[0];}
				case (2): {p[1].setNextOp(p[0]);if (!p[2].isEpsilon()) {return Global.imp(p[1],p[2]);} return p[1];}
				case (4): {if (!p[1].isEpsilon()) {return Global.or(p[0],p[1]);} return p[0];}
				case (5): {p[1].setNextOp(p[0]);if (!p[2].isEpsilon()) {return Global.or(p[1],p[2]);} return p[1];}
				case (7): {if (!p[1].isEpsilon()) {return Global.and(p[0],p[1]);} return p[0];}
				case (8): {p[1].setNextOp(p[0]);if (!p[2].isEpsilon()) {return Global.and(p[1],p[2]);} return p[1];}
				case (10): {if (!p[1].isEpsilon()) {return Global.eq(p[0],p[1]);} return p[0];}
				case (11): {p[1].setNextOp(p[0]);if (!p[2].isEpsilon()) {return Global.eq(p[1],p[2]);} return p[1];}
				case (13): {if (!p[1].isEpsilon()) {return Global.add(p[0],p[1]);} return p[0];}
				case (14): {p[1].setNextOp(p[0]);if (!p[2].isEpsilon()) {return Global.add(p[1],p[2]);} return p[1];}
				case (16): {if (!p[1].isEpsilon()) {return Global.mul(p[0],p[1]);} return p[0];}
				case (17): {p[1].setNextOp(p[0]);if (!p[2].isEpsilon()) {return Global.mul(p[1],p[2]);} return p[1];}
				case (19): return Global.not(p[1]);
				case (21): return p[1];
				case (23): return Global.neg(p[1]);
				case (37): return p[0].value("1");
				case (38): return p[0].value("0");
				case (39): return p[0].get(p[0]);
				case (40): {return Local.sset(p[1].value("value"),p[1].function(p[2]));}
				case (41): return p[0].value(OutputHandler.input(p[1].getVal()));
				case (42): return p[0].value("Input");
				case (45): {return p[0].value(p[0].getVal()+p[1].getVal());}
				case (46): {return Global.castTo(p[1].getVal(),p[3]);}
				case (48): return p[0].value(p[1].getVal()+";"+p[3].getVal());
				case (49): return p[0].value("");
				case (50): return p[0].value(p[0].getVal()+":"+p[1].getVal());
				case (51): return p[0].value("");
				case (52): return p[1].value(p[0].getVal()+","+p[1].getVal());
				case (54): return p[1];
				case (57): return p[2];
				case (59): return p[1];
				case (61): {if (p[1].getNext()==null) return p[0].set(p[0],p[1]);return Local.sset(p[1].value("value"),p[0].function(p[1]));}
				case (62): {return Local.sset(p[1].value("value"),p[2].value("42"));}
				case (63): {return p[1];}
				case (66): {p[0].setNextOp(p[1]);return p[0];}
				case (67): {p[0].setNextOp(p[1]);return p[0];}
				case (68): return p[1];
				case (70): {Local.push();return p[1];}
				case (71): return p[1];
				case (76): return p[1];
				case (77): return p[1];
				case (79): return p[1];
				case (83): return p[1];
				case (92): return p[1];
				case (93): {OutputHandler.print(p[1].getVal());return p[1];}
				case (94): {OutputHandler.message(p[1].getVal());return p[1];}
				case (95): {OutputHandler.pause("Press ENTER to continue ");return p[0];}
				case (99): return p[0].value("");
				case (100): return Global.trim(p[0]);
				case (101): return p[1];
				case (102): {return p[0].function(p[1]);}
			}
		return p[0];
	}
}
