package mocman.interpreter.syntax;

import mocman.interpreter.syntax.token.*;
import mocman.interpreter.syntax.*;
import mocman.interpreter.*;
import mocman.interpreter.modules.*;
public class Global implements ITreeNode
{
	private static Universe<Integer> univ=new Universe<Integer>();
	private int rule;
	private ITreeNode nextop;
	public void setValue(String s)
	{
		strVal=s;
	}
	public int get(String s)
	{
		return univ.get(s,0);
	}
	public void set(String s,int v)
	{
		univ.set(s,v);
	}
	protected String strVal;
	public Global()
	{
		//System.out.println("global");
	}
	public void run(ITreeNode[] p)
	{
	}
	public void setRule(int i)
	{
		rule=i;
	}
	public void build(String s,int rule)
	{
		this.rule=rule;
		strVal=s;
	}
	public int getRule()
	{
		return rule;
	}
	public String getVal()
	{
		return strVal;
	}
	public ITreeNode get(ITreeNode i)
	{
		return Global.sget(i);
	}
	public ITreeNode set(ITreeNode v,ITreeNode i)
	{
		return Global.sset(v,i);
	}
	public static ITreeNode sget(ITreeNode i)
	{
		Global p=new Global();
		p.strVal=new Integer(p.get(i.getVal())).toString();
		return p;
	}
	public static ITreeNode sset(ITreeNode i, ITreeNode v)
	{
		Global p = new Global();
		p.set(i.getVal(),Integer.parseInt(v.getVal()));
		p.strVal=v.getVal();
		return p;
	}
	public boolean isEpsilon()
	{
		if (getVal()==null) return true;
		if (getVal().equals("")) return true;
		if (getVal().equals("epsilon")) return true;
		return false;
	}
	public static ITreeNode epsilon()
	{
		Global p = new Global();
		p.strVal="";
		return p;
	}
	public static ITreeNode not(ITreeNode i)
	{
		ITreeNode p=i.clone();
		p.setValue("0");
		if (i.getVal().equals("0")) p.setValue("1");
		return p;
	}
	public static ITreeNode neg(ITreeNode i)
	{
		ITreeNode p=i.clone();
		Integer q=-Integer.parseInt(i.getVal());
		p.setValue(q.toString());
		return p;
	}
	public static ITreeNode add(ITreeNode a,ITreeNode b)
	{
		ITreeNode p=a.clone();
		Integer q=new Integer(0);
		if (b.getNext().getVal().equals("+")) q=Integer.parseInt(a.getVal())+Integer.parseInt(b.getVal());
		if (b.getNext().getVal().equals("-")) q=Integer.parseInt(a.getVal())-Integer.parseInt(b.getVal());
		p.setValue(q.toString());
		p.setNextOp(a.getNext());
		return p;
	}
	public static ITreeNode mul(ITreeNode a,ITreeNode b)
	{
		ITreeNode p=a.clone();
		Integer q=new Integer(0);
		if (b.getNext().getVal().equals("*")) q=Integer.parseInt(a.getVal())*Integer.parseInt(b.getVal());
		if (b.getNext().getVal().equals("/")) q=Integer.parseInt(a.getVal())/Integer.parseInt(b.getVal());
		if (b.getNext().getVal().equals("%")) q=Integer.parseInt(a.getVal())%Integer.parseInt(b.getVal());
		p.setValue(q.toString());
		p.setNextOp(a.getNext());
		return p;
	}
	public static int bln(int i)
	{
		if (i>=1) return 1;
		return 0;
	}
	public static int blnb(boolean b)
	{
		if (b) return 1;
		return 0;
	}
	public static ITreeNode or(ITreeNode a,ITreeNode b)
	{
		ITreeNode p=a.clone();
		Integer q=new Integer(0);
		q=bln(bln(Integer.parseInt(a.getVal()))+bln(Integer.parseInt(b.getVal())));
		p.setValue(q.toString());
		p.setNextOp(a.getNext());
		return p;
	}
	public static ITreeNode and(ITreeNode a,ITreeNode b)
	{
		ITreeNode p=a.clone();
		Integer q=new Integer(0);
		q=bln(bln(Integer.parseInt(a.getVal()))*bln(Integer.parseInt(b.getVal())));
		p.setValue(q.toString());
		p.setNextOp(a.getNext());
		return p;
	}
	//TODO: eq
	public static ITreeNode eq(ITreeNode a,ITreeNode b)
	{
		ITreeNode p=a.clone();
		Integer q=new Integer(0);
		if (b.getNext().getVal().equals("=")) q=blnb(Integer.parseInt(a.getVal())==(Integer.parseInt(b.getVal())));
		if (b.getNext().getVal().equals("not")) q=blnb(Integer.parseInt(a.getVal())!=(Integer.parseInt(b.getVal())));
		if (b.getNext().getVal().equals("<")) q=blnb(Integer.parseInt(a.getVal())<(Integer.parseInt(b.getVal())));
		if (b.getNext().getVal().equals(">")) q=blnb(Integer.parseInt(a.getVal())>(Integer.parseInt(b.getVal())));
		if (b.getNext().getVal().equals("<=")) q=blnb(Integer.parseInt(a.getVal())<=(Integer.parseInt(b.getVal())));
		if (b.getNext().getVal().equals(">=")) q=blnb(Integer.parseInt(a.getVal())>=(Integer.parseInt(b.getVal())));
		p.setValue(q.toString());
		p.setNextOp(a.getNext());
		return p;
	}
	
	public Global clone()
	{
		Global g=new Global();
		g.setValue(getVal());
		return g;
	}
	
	public static ITreeNode imp(ITreeNode a,ITreeNode b)
	{
		ITreeNode p=a.clone();
		Integer q=new Integer(0);
		q=bln(1-(bln(Integer.parseInt(a.getVal())))+bln(Integer.parseInt(b.getVal())));
		p.setValue(q.toString());
		p.setNextOp(a.getNext());
		return p;
	}

	public ITreeNode value(String s)
	{
		return Global.svalue(s);
	}

	public ITreeNode getNext()
	{
		return nextop;
	}
	public void setNextOp(ITreeNode t)
	{
		nextop=t;
	}
	public static ITreeNode svalue(String s)
	{
		Global p=new Global();
		p.setValue(s);
		return p;
	}
	public ITreeNode function(ITreeNode i)
	{
		System.out.println("Not Implemented!");
		return i;
	}
	public static ITreeNode castTo(String s,ITreeNode t)
	{
		ITreeNode p=new Local();
		if (s.equals("global")) p=new Global();
		if (s.charAt(0)=='M')
		{
			p=Module.create(s);
		}
		if (s.charAt(0)=='S')
		{
			p=Script.create(s);
		}
		p.setValue(t.getVal());
		return p;
	}
	public static ITreeNode trim(ITreeNode n)
	{
		ITreeNode p=n.clone();
		p.setValue(n.getVal().substring(1,n.getVal().length()-1));
		return p;
	}
}
