package mocman.util.data;

import java.awt.*;

/**
 * Generic Node type
 * It contains 2 dimensional coordinates,
 * a value
 * and a color.
 * It is designed to be shown on an awt from.
 * This class is used later as nodes and edges.
 * @author <a href="mailto:mocman@inf.elte.hu">Tibor Zoltan Varkonyi</a>
 * @param T value type of the represented node
 */
public class Node<T>
{
	private T value;
	private int x;
	private int y;
	private Color color;

/** Default constructor */
	public Node() {}

/** Value only constructor 
 * @param val the value
 */
	public Node(T val)
	{
		color=Color.white;
		value=val;
	}

/** Full constructor 
 * @param val the value
 * @param x the horizontal coordinate
 * @param y the vertical coordinate
 * @param color color
 */
	public Node(T val,int x,int y,Color color)
	{
		this.color=color;
		value=val;
		this.x=x;
		this.y=y;
	}
/** Gets the X coordinate */
	public int getX()
	{
		return x;
	}

/** Gets the Y coordinate */
	public int getY()
	{
		return y;
	}

/** Sets the X coordinate */
	public void setX(int i)
	{
		x=i;
	}

/** Sets the Y coordinate */
	public void setY(int i)
	{
		y=i;
	}

/** Gets the value */
	public T getValue()
	{
		return value;
	}

/** Sets the value */
	public void setValue(T i)
	{
		value=i;
	}

/** Sets the color */
	public void setColor(Color c)
	{
		color=c;
	}

/** Gets the color */
	public Color getColor()
	{
		return color;
	}
}

